=== debian/changelog ===
bart (0.3.00-1) unstable; urgency=medium

  * Initial release. (Closes: #806762)

 -- Martin Uecker <martin.uecker@med.uni-goettingen.de>  Tue, 09 Feb 2016 23:42:36 +0100
