=== debian/control ===
Source: bart
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Martin Uecker <martin.uecker@med.uni-goettingen.de>
Section: science
Priority: optional
Standards-Version: 3.9.7
Build-Depends: debhelper (>= 9), libfftw3-dev, liblapack-dev | liblapack.so, libpng-dev
Vcs-Browser: https://anonscm.debian.org/cgit/debian-med/bart.git
Vcs-Git: https://anonscm.debian.org/git/debian-med/bart.git
Homepage: https://mrirecon.github.io/bart/

Package: bart
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: octave-bart
Description: tools for computational magnetic resonance imaging
 The Berkeley Advanced Reconstruction Toolbox (BART) is a free and
 open-source image-reconstruction framework for Computational Magnetic
 Resonance Imaging. It consists of a programming library and a toolbox
 of command-line programs. The library provides common operations on
 multi-dimensional arrays, Fourier and wavelet transforms, as well as
 generic implementations of iterative optimization algorithms. The
 command-line tools provide direct access to basic operations on
 multi-dimensional arrays as well as efficient implementations of
 many calibration and reconstruction algorithms for parallel imaging
 and compressed sensing.

Package: libbart-dev
Architecture: any
Depends: ${misc:Depends}
Section: libdevel
Description: Development files for BART
 The Berkeley Advanced Reconstruction Toolbox (BART) is a free and
 open-source image-reconstruction framework for Computational Magnetic
 Resonance Imaging.
 .
 This package provides headers and static libraries.

Package: octave-bart
Architecture: all
Depends: bart, ${misc:Depends}
Recommends: octave
Description: Octave bindings for BART
 The Berkeley Advanced Reconstruction Toolbox (BART) is a free and
 open-source image-reconstruction framework for Computational Magnetic
 Resonance Imaging.
 .
 This package provides Octave bindings for BART.
