=== debian/changelog ===
bart (0.4.00-1) unstable; urgency=medium

  [ Martin Uecker ]
  * New upstream version.

  [ Andreas Tille ]
  * debhelper 10
  * d/watch: version=4
  * cme fix dpkg-control
  * Add missing Build-Depends: liblapacke-dev
  * hardening=+all

 -- Martin Uecker <martin.uecker@med.uni-goettingen.de>  Sat, 14 Jan 2017 14:41:50 +0100
