=== debian/control ===
--- 
+++ 
@@ -3,15 +3,20 @@
 Uploaders: Martin Uecker <martin.uecker@med.uni-goettingen.de>
 Section: science
 Priority: optional
-Standards-Version: 3.9.7
-Build-Depends: debhelper (>= 9), libfftw3-dev, liblapack-dev | liblapack.so, libpng-dev
+Build-Depends: debhelper (>= 10),
+               libfftw3-dev,
+               liblapack-dev | liblapack.so,
+               libpng-dev,
+               liblapacke-dev
+Standards-Version: 3.9.8
 Vcs-Browser: https://anonscm.debian.org/cgit/debian-med/bart.git
 Vcs-Git: https://anonscm.debian.org/git/debian-med/bart.git
 Homepage: https://mrirecon.github.io/bart/
 
 Package: bart
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}
+Depends: ${shlibs:Depends},
+         ${misc:Depends}
 Suggests: octave-bart
 Description: tools for computational magnetic resonance imaging
  The Berkeley Advanced Reconstruction Toolbox (BART) is a free and
@@ -27,8 +32,8 @@
 
 Package: libbart-dev
 Architecture: any
+Section: libdevel
 Depends: ${misc:Depends}
-Section: libdevel
 Description: Development files for BART
  The Berkeley Advanced Reconstruction Toolbox (BART) is a free and
  open-source image-reconstruction framework for Computational Magnetic
@@ -38,7 +43,8 @@
 
 Package: octave-bart
 Architecture: all
-Depends: bart, ${misc:Depends}
+Depends: bart,
+         ${misc:Depends}
 Recommends: octave
 Description: Octave bindings for BART
  The Berkeley Advanced Reconstruction Toolbox (BART) is a free and
