## bart 0.4.02

=== CMakeLists.txt ===
--- 
+++ 
@@ -36,7 +36,35 @@
 ## -message(STATUS "Looking for packages in : ${CMAKE_PREFIX_PATH}")
 
 ## Options
-##- TODO option(USE_CUDA    "Provide support for CUDA processing" OFF)
+option(USE_CUDA    "Provide support for CUDA processing" OFF)
+if(USE_CUDA)
+  enable_language(CXX)
+  find_package(CUDA)
+  add_definitions(-DUSE_CUDA)
+  CUDA_INCLUDE_DIRECTORIES(${CMAKE_CURRENT_LIST_DIR}/src)
+  # set(CUDA_NVCC_FLAGS "-DUSE_CUDA;-Xcompiler;-fPIC;-Xcompiler;-fopenmp;-O3;-arch=sm_20;-m64;-ccbin ${CMAKE_C_COMPILER}")
+  set(CUDA_NVCC_FLAGS "-DUSE_CUDA;-Xcompiler;-fPIC;-Xcompiler;-fopenmp;-O3;-arch=sm_20;-ccbin ${CMAKE_C_COMPILER}")
+  macro(bart_add_executable target_name)
+    CUDA_ADD_EXECUTABLE(${target_name} ${ARGN})
+    CUDA_ADD_CUFFT_TO_TARGET(${target_name})
+    CUDA_ADD_CUBLAS_TO_TARGET(${target_name})
+    target_link_libraries(${target_name} ${CUDA_LIBRARIES})
+  endmacro(bart_add_executable)
+  macro(bart_add_library target_name)
+    CUDA_ADD_LIBRARY(${target_name} ${ARGN} STATIC)
+    CUDA_ADD_CUFFT_TO_TARGET(${target_name})
+    CUDA_ADD_CUBLAS_TO_TARGET(${target_name})
+    target_link_libraries(${target_name} ${CUDA_LIBRARIES})
+  endmacro(bart_add_library)  
+else()
+  macro(bart_add_executable target_name)
+    add_executable(${target_name} ${ARGN})
+  endmacro(bart_add_executable)
+  macro(bart_add_library target_name)
+    add_library(${target_name} ${ARGN})
+  endmacro(bart_add_library)
+endif(USE_CUDA)
+
 ##- TODO option(USE_ACML    "Provide support for ACML processing" OFF)
 find_package(OpenMP)
 if (OPENMP_FOUND)
@@ -107,13 +135,13 @@
   ## for cblas and lapacke.  This method is not very robust to older
   ## versions of lapack that might be able to be supported.
   ## It is know to work local builds
-  include( ${CMAKE_CURRENT_LIST_DIR}/cmake/FindLAPACKE.cmake )
+  find_package(LAPACKE REQUIRED)
   if(LAPACKE_FOUND)
      set(LINALG_VENDOR_FOUND TRUE)
      set(LINALG_VENDOR "LAPACKE")
      set(LINALG_INCLUDE_DIRS ${LAPACKE_INCLUDE_DIRS})
      set(LINALG_LIBRARIES ${LAPACKE_LIBRARIES})
-  endif()
+   endif()
 endif()
 
 ##
@@ -209,7 +237,7 @@
   endif()
 endmacro()
 
-set(BART_SUPPORT_LIBS calib misc dfwavelet grecon iter linops lowrank noir noncart num sake sense simu wavelet2 wavelet3)
+set(BART_SUPPORT_LIBS calib misc dfwavelet grecon iter linops lowrank nlops noir noncart num sake sense simu wavelet)
 if(USE_ISMRMRD)
   list(APPEND BART_SUPPORT_LIBS ismrm)
   link_directories(${ISMRMRD_LIBRARY_DIRS})
@@ -220,8 +248,12 @@
 foreach(curr_lib ${BART_SUPPORT_LIBS})
     file(GLOB ${curr_lib}_SRCS "src/${curr_lib}/*.c")
     list(APPEND bart_support_SRCS ${${curr_lib}_SRCS})
+    if(USE_CUDA)
+      file(GLOB ${curr_lib}_SRCS "src/${curr_lib}/*.cu")
+      list(APPEND bart_support_SRCS ${${curr_lib}_SRCS})
+    endif()
 endforeach()
-add_library(bartsupport ${bart_support_SRCS})
+bart_add_library(bartsupport ${bart_support_SRCS})
 target_link_libraries(bartsupport ${PNG_LIBRARIES} ${FFTWF_LIBRARIES} ${LINALG_LIBRARIES})
 if(USE_ISMRMRD)
   target_link_libraries(bartsupport ${ISMRMRD_LIBRARIES})
@@ -239,7 +271,7 @@
   CONFIG_BY_REPLACEMENT( ${CMAKE_CURRENT_LIST_DIR}/src/main.c ${CMAKE_CURRENT_BINARY_DIR}/StandAloneCode/${curr_prog}.c
                          "/* Generated by cmake */"
                          "main_real" "main_${curr_prog}")
-  add_executable(${curr_prog} ${CMAKE_CURRENT_BINARY_DIR}/StandAloneCode/${curr_prog}.c ${CMAKE_CURRENT_LIST_DIR}/src/${curr_prog}.c)
+  bart_add_executable(${curr_prog} ${CMAKE_CURRENT_BINARY_DIR}/StandAloneCode/${curr_prog}.c ${CMAKE_CURRENT_LIST_DIR}/src/${curr_prog}.c)
   target_link_libraries(${curr_prog} bartsupport )
   install(TARGETS ${curr_prog}
         RUNTIME DESTINATION bin
@@ -254,26 +286,3 @@
 #==============================================
 set(EXTERN_LIST "\n\n/* Generated by cmake */\n")
 foreach(driver ${ALLPROGS})
-   set(EXTERN_LIST "${EXTERN_LIST}extern int main_${driver}(int argc, char* argv[])__EOL__\n")
-endforeach()
-file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/CombinedCode)
-## Configure include header
-CONFIG_BY_REPLACEMENT( "${CMAKE_CURRENT_LIST_DIR}/src/main.h" "${CMAKE_CURRENT_BINARY_DIR}/CombinedCode/config_main.h"
-                       "/* Generated by cmake */"
-                       "MAP(DECLMAIN, MAIN_LIST)" "${EXTERN_LIST}"
-                       "misc/cppmap.h" "stdio.h")             ## Replacement 3 no longer need this include 
-include_directories(${CMAKE_CURRENT_BINARY_DIR}/CombinedCode)
-
-#==============================================
-set(DRIVER_LIST "\n\n/* Generated by cmake */\n")
-foreach(driver ${ALLPROGS})
-   set(DRIVER_LIST "${DRIVER_LIST}{ main_${driver}, \"${driver}\" },\n")
-endforeach()
-set(ALL_BART_SRCS "")
-foreach(curr_prog ${ALLPROGS})
-  CONFIG_BY_REPLACEMENT( "${CMAKE_CURRENT_LIST_DIR}/src/${curr_prog}.c" "${CMAKE_CURRENT_BINARY_DIR}/CombinedCode/${curr_prog}.c"
-                         "/* Generated by cmake */\n#include \"config_main.h\""
-                         "MAP(DENTRY, MAIN_LIST)" "${DRIVER_LIST}")
-  list(APPEND ALL_BART_SRCS "${CMAKE_CURRENT_BINARY_DIR}/CombinedCode/${curr_prog}.c")
-endforeach()
-foreach(curr_prog bart)
