=== Makefile ===
--- 
+++ 
@@ -38,10 +38,30 @@
 endif
 
 ifeq ($(BUILDTYPE), MacOSX)
-	MACPORTS?=1
-endif
-
-ARFLAGS = r
+	MACPORTS ?= 1
+endif
+
+
+ifeq ($(BUILDTYPE), Linux)
+	# as the defaults changed on most Linux distributions
+	# explicitly specify non-deterministic archives to not break make
+	ARFLAGS ?= rsU
+else
+	ARFLAGS ?= rs
+endif
+
+
+ifeq ($(UNAME),Cygwin)
+	BUILDTYPE = Cygwin
+	NOLAPACKE ?= 1
+endif
+
+ifeq ($(UNAME),CYGWIN_NT-10.0)
+	BUILDTYPE = Cygwin
+	NOLAPACKE ?= 1
+endif
+
+
 
 
 # Paths
@@ -130,11 +150,11 @@
 
 MODULES = -lnum -lmisc -lnum -lmisc
 
-MODULES_pics = -lgrecon -lsense -liter -llinops -lwavelet3 -llowrank -lnoncart
-MODULES_sqpics = -lsense -liter -llinops -lwavelet3 -llowrank -lnoncart
-MODULES_pocsense = -lsense -liter -llinops -lwavelet3
-MODULES_nlinv = -lnoir -liter
-MODULES_bpsense = -lsense -lnoncart -liter -llinops -lwavelet3
+MODULES_pics = -lgrecon -lsense -liter -llinops -lwavelet -llowrank -lnoncart
+MODULES_sqpics = -lsense -liter -llinops -lwavelet -llowrank -lnoncart
+MODULES_pocsense = -lsense -liter -llinops -lwavelet
+MODULES_nlinv = -lnoir -liter -lnlops -llinops
+MODULES_bpsense = -lsense -lnoncart -liter -llinops -lwavelet
 MODULES_itsense = -liter -llinops
 MODULES_ecalib = -lcalib
 MODULES_ecaltwo = -lcalib
@@ -142,19 +162,21 @@
 MODULES_walsh = -lcalib
 MODULES_calmat = -lcalib
 MODULES_cc = -lcalib
+MODULES_ccapply = -lcalib
 MODULES_estvar = -lcalib
 MODULES_nufft = -lnoncart -liter -llinops
 MODULES_rof = -liter -llinops
-MODULES_bench = -lwavelet3 -lwavelet2 -llinops
+MODULES_bench = -lwavelet -llinops
 MODULES_phantom = -lsimu
-MODULES_bart = -lbox -lgrecon -lsense -lnoir -liter -llinops -lwavelet3 -lwavelet2 -llowrank -lnoncart -lcalib -lsimu -lsake -ldfwavelet
+MODULES_bart = -lbox -lgrecon -lsense -lnoir -liter -llinops -lwavelet -llowrank -lnoncart -lcalib -lsimu -lsake -ldfwavelet -lnlops
 MODULES_sake = -lsake
-MODULES_wave = -liter -lwavelet3 -llinops -lsense
-MODULES_threshold = -llowrank -liter -ldfwavelet -llinops -lwavelet2 -lwavelet3
+MODULES_wave = -liter -lwavelet -llinops -lsense
+MODULES_threshold = -llowrank -liter -ldfwavelet -llinops -lwavelet
 MODULES_fakeksp = -lsense -llinops
 MODULES_lrmatrix = -llowrank -liter -llinops
 MODULES_estdims = -lnoncart -llinops
 MODULES_ismrmrd = -lismrm
+MODULES_wavelet = -llinops -lwavelet
 
 
 MAKEFILES = $(root)/Makefiles/Makefile.*
@@ -168,6 +190,12 @@
 TMRI += ismrmrd
 MODULES_bart += -lismrm
 endif
+
+ifeq ($(NOLAPACKE),1)
+CPPFLAGS += -DNOLAPACKE
+MODULES += -llapacke
+endif
+
 
 
 XTARGETS += $(TBASE) $(TFLP) $(TNUM) $(TIO) $(TRECO) $(TCALIB) $(TMRI) $(TSIM)
@@ -194,7 +222,7 @@
 
 
 CPPFLAGS += $(DEPFLAG) -I$(srcdir)/
-CFLAGS += -std=c99 -I$(srcdir)/
+CFLAGS += -std=gnu11 -I$(srcdir)/
 CXXFLAGS += -I$(srcdir)/
 
 
@@ -226,7 +254,9 @@
 CUDA_L :=  
 endif
 
-NVCCFLAGS = -DUSE_CUDA -Xcompiler -fPIC -Xcompiler -fopenmp -O3 -arch=sm_20 -I$(srcdir)/ -m64 -ccbin $(CC)
+# sm_20 no longer supported in CUDA 9
+GPUARCH_FLAGS ?= 
+NVCCFLAGS = -DUSE_CUDA -Xcompiler -fPIC -Xcompiler -fopenmp -O3 $(GPUARCH_FLAGS) -I$(srcdir)/ -m64 -ccbin $(CC)
 #NVCCFLAGS = -Xcompiler -fPIC -Xcompiler -fopenmp -O3  -I$(srcdir)/
 
 
@@ -258,7 +288,12 @@
 ifeq ($(BUILDTYPE), MacOSX)
 BLAS_L := -L$(BLAS_BASE)/lib -lopenblas
 else
+ifeq ($(NOLAPACKE),1)
+BLAS_L := -L$(BLAS_BASE)/lib -llapack -lblas
+CPPFLAGS += -Isrc/lapacke
+else
 BLAS_L := -L$(BLAS_BASE)/lib -llapacke -lblas
+endif
 endif
 endif
 
@@ -406,6 +441,7 @@
 
 clean:
 	rm -f `find $(srcdir) -name "*.o"`
+	rm -f utests/*.o
 	rm -f $(patsubst %, %, $(UTARGETS))
 	rm -f $(root)/lib/.*.lock
