=== debian/changelog ===
bart (0.4.02-2) unstable; urgency=medium

  * Turn off unit tests on some architectures.

 -- Martin Uecker <martin.uecker@med.uni-goettingen.de>  Mon, 27 Nov 2017 23:21:21 +0100

bart (0.4.02-1) unstable; urgency=medium

  * New upstream version.
  * Simple test for autopkgtest.
  * Standards-Version: 4.1.1

 -- Martin Uecker <martin.uecker@med.uni-goettingen.de>  Mon, 27 Nov 2017 08:32:12 +0100
