=== debian/control ===
--- 
+++ 
@@ -8,7 +8,7 @@
                liblapack-dev | liblapack.so,
                libpng-dev,
                liblapacke-dev
-Standards-Version: 3.9.8
+Standards-Version: 4.1.1
 Vcs-Browser: https://anonscm.debian.org/cgit/debian-med/bart.git
 Vcs-Git: https://anonscm.debian.org/git/debian-med/bart.git
 Homepage: https://mrirecon.github.io/bart/
