=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

DEB_BUILD_ARCH ?= $(shell dpkg-architecture -qDEB_BUILD_ARCH)

# Some tests fail on the following architectures probably
# due to minor differences in floating point processing.
# For now, just turn it off...
NOTEST_ARCHS=i386 mips mipsel hurd-i386 kfreebsd-i386 m68k sh4

%:
	dh $@

override_dh_auto_test:
ifeq (,$(filter $(NOTEST_ARCHS), $(DEB_BUILD_ARCH)))
	make utest
endif
