=== debian/tests/control ===
Test-Command: /usr/bin/bart version
Depends: bart
