## bart 0.4.03

=== CMakeLists.txt ===
--- 
+++ 
@@ -11,7 +11,7 @@
 macro(use_c99)
   if (CMAKE_VERSION VERSION_LESS "3.1")
     if (CMAKE_C_COMPILER_ID STREQUAL "GNU")
-      set (CMAKE_C_FLAGS "--std=gnu99 ${CMAKE_C_FLAGS}")
+      set (CMAKE_C_FLAGS "--std=gnu11 ${CMAKE_C_FLAGS}")
     endif ()
   else ()
     set (CMAKE_C_STANDARD 99)
@@ -264,20 +264,20 @@
         ARCHIVE DESTINATION lib/static)
 
 
-## PASS #1:  Build stand-alone programs
-## Generate stand alone programs
-file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/StandAloneCode)
-foreach(curr_prog ${ALLPROGS})
-  CONFIG_BY_REPLACEMENT( ${CMAKE_CURRENT_LIST_DIR}/src/main.c ${CMAKE_CURRENT_BINARY_DIR}/StandAloneCode/${curr_prog}.c
-                         "/* Generated by cmake */"
-                         "main_real" "main_${curr_prog}")
-  bart_add_executable(${curr_prog} ${CMAKE_CURRENT_BINARY_DIR}/StandAloneCode/${curr_prog}.c ${CMAKE_CURRENT_LIST_DIR}/src/${curr_prog}.c)
-  target_link_libraries(${curr_prog} bartsupport )
-  install(TARGETS ${curr_prog}
-        RUNTIME DESTINATION bin
-        LIBRARY DESTINATION lib
-        ARCHIVE DESTINATION lib/static)
-endforeach()
+### PASS #1:  Build stand-alone programs
+### Generate stand alone programs
+#file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/StandAloneCode)
+#foreach(curr_prog ${ALLPROGS})
+#  CONFIG_BY_REPLACEMENT( ${CMAKE_CURRENT_LIST_DIR}/src/main.c ${CMAKE_CURRENT_BINARY_DIR}/StandAloneCode/${curr_prog}.c
+#                         "/* Generated by cmake */"
+#                        "main_real" "main_${curr_prog}")
+#  bart_add_executable(${curr_prog} ${CMAKE_CURRENT_BINARY_DIR}/StandAloneCode/${curr_prog}.c ${CMAKE_CURRENT_LIST_DIR}/src/${curr_prog}.c)
+#  target_link_libraries(${curr_prog} bartsupport )
+#  install(TARGETS ${curr_prog}
+#        RUNTIME DESTINATION bin
+#        LIBRARY DESTINATION lib
+#        ARCHIVE DESTINATION lib/static)
+#endforeach()
 
 ## More crafty file manipulation so that we maintain backward comaptibility
 ## with the Makefile
