=== Makefile ===
--- 
+++ 
@@ -24,7 +24,7 @@
 ISMRMRD?=0
 
 DESTDIR ?= /
-PREFIX ?= usr/
+PREFIX ?= usr/local/
 
 BUILDTYPE = Linux
 UNAME = $(shell uname -s)
@@ -91,7 +91,7 @@
 CXXFLAGS ?= $(OPT)
 
 ifeq ($(BUILDTYPE), MacOSX)
-	CC ?= gcc-mp-4.7
+	CC ?= gcc-mp-6
 else
 	CC ?= gcc
 	# for symbols in backtraces
