=== debian/changelog ===
bart (0.4.03-2) unstable; urgency=medium

  * Add missing header to libbart-dev. (Closes: #897466)

 -- Martin Uecker <martin.uecker@med.uni-goettingen.de>  Thu, 03 May 2018 21:44:55 +0200

bart (0.4.03-1) unstable; urgency=medium

  [ Martin Uecker ]
  * New upstream version.
  * Update copyright file.
  * Fix install.
  * Standards-Version: 4.1.4
  * Secure url for copyright format.
  * Make vcs links point to salsa.

  [ Andreas Tille ]
  * debhelper 11

 -- Martin Uecker <martin.uecker@med.uni-goettingen.de>  Fri, 27 Apr 2018 21:34:11 +0200
