=== debian/control ===
--- 
+++ 
@@ -3,14 +3,14 @@
 Uploaders: Martin Uecker <martin.uecker@med.uni-goettingen.de>
 Section: science
 Priority: optional
-Build-Depends: debhelper (>= 10),
+Build-Depends: debhelper (>= 11~),
                libfftw3-dev,
                liblapack-dev | liblapack.so,
                libpng-dev,
                liblapacke-dev
-Standards-Version: 4.1.1
-Vcs-Browser: https://anonscm.debian.org/cgit/debian-med/bart.git
-Vcs-Git: https://anonscm.debian.org/git/debian-med/bart.git
+Standards-Version: 4.1.4
+Vcs-Browser: https://salsa.debian.org/med-team/bart
+Vcs-Git: https://salsa.debian.org/med-team/bart.git
 Homepage: https://mrirecon.github.io/bart/
 
 Package: bart
